<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celGameFactoryManager Class Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">celGameFactoryManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="celGameFactoryManager" -->
<p>This is an interface you should implement in order to manage the events from the factory of game sessions.  
 <a href="classcelGameFactoryManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="network_8h_source.html">physicallayer/network.h</a>&gt;</code></p>

<p><a href="classcelGameFactoryManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2">GameInfoReceived</a> (<a class="el" href="classcelGameInfo.html">celGameInfo</a> *game_info, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> server_latency)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The game factory is searching for available games (it has been started with <a class="el" href="structiCelGameFactory.html#a7756c198de88c4b38ad29199dd92e1ca" title="Start to search for the list of available games with the same game name, protocol version and game ty...">iCelGameFactory::StartSearchForGameList</a>), and a game has been found.  <a href="#a39c1ea28335081be506112b125b924b2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#a988219ab5ffebdadbc1b91ea4f29eda5">GetClientEventBaseline</a> (celClientEventType event_type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the baseline of a client event.  <a href="#a988219ab5ffebdadbc1b91ea4f29eda5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#a1b0660f3f2c949f4c8df6af2053707dd">GetNetworkLinkBaseline</a> (celNetworkLinkType link_type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the baseline of a network link.  <a href="#a1b0660f3f2c949f4c8df6af2053707dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#ae05afe2920598098eeccb26327aea192">GetServerEventBaseline</a> (celServerEventType event_type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the baseline of a server event.  <a href="#ae05afe2920598098eeccb26327aea192"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#ab2b906cb592b493f0563221e4238333f">InitClient</a> (<a class="el" href="structiCelGame.html">iCelGame</a> *game)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A client is created and has to be initialized.  <a href="#ab2b906cb592b493f0563221e4238333f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#abef391e780d2a9874f70a674cf8b741a">InitServer</a> (<a class="el" href="structiCelGame.html">iCelGame</a> *game)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A server is created and has to be initialized.  <a href="#abef391e780d2a9874f70a674cf8b741a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameFactoryManager.html#a725d679aa5ef5845a020476038d85ee1">ServerNetworkStateChanged</a> (celServerNetworkState new_state, celServerNetworkState previous_state, const char *reason=&quot;&quot;)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The state of the network connection from the client to the server has changed.  <a href="#a725d679aa5ef5845a020476038d85ee1"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is an interface you should implement in order to manage the events from the factory of game sessions. </p>
<p>You can use it to:</p>
<ul>
<li>receive the information on new games accessible.</li>
<li>catch the changes of the connection state from the client to the server.</li>
<li>initialize the client and the server.</li>
<li>provide the baselines of the client and server events, and of the network links. </li>
</ul>

<p>Definition at line <a class="el" href="network_8h_source.html#l00237">237</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a39c1ea28335081be506112b125b924b2"></a><!-- doxytag: member="celGameFactoryManager::GameInfoReceived" ref="a39c1ea28335081be506112b125b924b2" args="(celGameInfo *game_info, csTicks server_latency)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2">celGameFactoryManager::GameInfoReceived</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameInfo.html">celGameInfo</a> *&#160;</td>
          <td class="paramname"><em>game_info</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>server_latency</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The game factory is searching for available games (it has been started with <a class="el" href="structiCelGameFactory.html#a7756c198de88c4b38ad29199dd92e1ca" title="Start to search for the list of available games with the same game name, protocol version and game ty...">iCelGameFactory::StartSearchForGameList</a>), and a game has been found. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">game_info</td><td>the info of the game. </td></tr>
    <tr><td class="paramname">server_latency</td><td>an estimation of the latency of the network connection from this client to the server. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="network_8h_source.html#l00250">250</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>

</div>
</div>
<a class="anchor" id="a988219ab5ffebdadbc1b91ea4f29eda5"></a><!-- doxytag: member="celGameFactoryManager::GetClientEventBaseline" ref="a988219ab5ffebdadbc1b91ea4f29eda5" args="(celClientEventType event_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a>&gt; <a class="el" href="classcelGameFactoryManager.html#a988219ab5ffebdadbc1b91ea4f29eda5">celGameFactoryManager::GetClientEventBaseline</a> </td>
          <td>(</td>
          <td class="paramtype">celClientEventType&#160;</td>
          <td class="paramname"><em>event_type</em></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the baseline of a client event. </p>
<p>Baselines are the default types and values of the fields of an event. They are used to limit the network traffic by delta-compression and by allowing the system to not be forced to send the types of the data. </p>
<p>It is not obligatory to provide the baselines and this function can return 0, but this can result in some network overhead. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00301">301</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1b0660f3f2c949f4c8df6af2053707dd"></a><!-- doxytag: member="celGameFactoryManager::GetNetworkLinkBaseline" ref="a1b0660f3f2c949f4c8df6af2053707dd" args="(celNetworkLinkType link_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a>&gt; <a class="el" href="classcelGameFactoryManager.html#a1b0660f3f2c949f4c8df6af2053707dd">celGameFactoryManager::GetNetworkLinkBaseline</a> </td>
          <td>(</td>
          <td class="paramtype">celNetworkLinkType&#160;</td>
          <td class="paramname"><em>link_type</em></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the baseline of a network link. </p>
<p>It is not obligatory to provide the baselines and this function can return 0, but this can result in some network overhead. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00317">317</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae05afe2920598098eeccb26327aea192"></a><!-- doxytag: member="celGameFactoryManager::GetServerEventBaseline" ref="ae05afe2920598098eeccb26327aea192" args="(celServerEventType event_type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a>&gt; <a class="el" href="classcelGameFactoryManager.html#ae05afe2920598098eeccb26327aea192">celGameFactoryManager::GetServerEventBaseline</a> </td>
          <td>(</td>
          <td class="paramtype">celServerEventType&#160;</td>
          <td class="paramname"><em>event_type</em></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the baseline of a server event. </p>
<p>It is not obligatory to provide the baselines and this function can return 0, but this can result in some network overhead. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00309">309</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab2b906cb592b493f0563221e4238333f"></a><!-- doxytag: member="celGameFactoryManager::InitClient" ref="ab2b906cb592b493f0563221e4238333f" args="(iCelGame *game)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classcelGameFactoryManager.html#ab2b906cb592b493f0563221e4238333f">celGameFactoryManager::InitClient</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelGame.html">iCelGame</a> *&#160;</td>
          <td class="paramname"><em>game</em></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A client is created and has to be initialized. </p>
<p>The <a class="el" href="structiCelGameClient.html" title="The main object to manage the client game logic.">iCelGameClient</a> object is accessible from the <a class="el" href="structiCelGame.html" title="A networked game.">iCelGame</a> object. </p>
<p>You should create here a physical layer which will be the copy of the physical layer of the server. You should wait for network links from the server before adding most entities, but you can start loading the level, ie the static entities. If the type of the game is CEL_NET_SINGLEPLAYER, you do not need to create a physical layer and you can access directly the one from the server. </p>
<p>You should register here the client manager. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00282">282</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>

</div>
</div>
<a class="anchor" id="abef391e780d2a9874f70a674cf8b741a"></a><!-- doxytag: member="celGameFactoryManager::InitServer" ref="abef391e780d2a9874f70a674cf8b741a" args="(iCelGame *game)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classcelGameFactoryManager.html#abef391e780d2a9874f70a674cf8b741a">celGameFactoryManager::InitServer</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelGame.html">iCelGame</a> *&#160;</td>
          <td class="paramname"><em>game</em></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A server is created and has to be initialized. </p>
<p>The <a class="el" href="structiCelGameServer.html" title="The main object to manage the server game logic.">iCelGameServer</a> object is accessible from the celGame object. </p>
<p>You should create here the physical layer, the initial entities and their behaviors. </p>
<p>You should register here the server manager. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00291">291</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>

</div>
</div>
<a class="anchor" id="a725d679aa5ef5845a020476038d85ee1"></a><!-- doxytag: member="celGameFactoryManager::ServerNetworkStateChanged" ref="a725d679aa5ef5845a020476038d85ee1" args="(celServerNetworkState new_state, celServerNetworkState previous_state, const char *reason=&quot;&quot;)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameFactoryManager.html#a725d679aa5ef5845a020476038d85ee1">celGameFactoryManager::ServerNetworkStateChanged</a> </td>
          <td>(</td>
          <td class="paramtype">celServerNetworkState&#160;</td>
          <td class="paramname"><em>new_state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">celServerNetworkState&#160;</td>
          <td class="paramname"><em>previous_state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>reason</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The state of the network connection from the client to the server has changed. </p>
<p>An extra comment can be specified when new_state is:</p>
<ul>
<li>CEL_NET_SERVER_INVALID_HOSTNAME: reason is the value of the hostname.</li>
<li>CEL_NET_SERVER_REJECTED_BAD_GAME: reason is the name of the game played by the server.</li>
<li>CEL_NET_SERVER_REJECTED_BAD_PROTOCOL: reason is the name of the protocol version used by the server.</li>
<li>CEL_NET_SERVER_REJECTED_UNAUTHORIZED: reason is the text given by the server to explain why this player has not been authorized to enter the game.</li>
<li>CEL_NET_SERVER_KICKED: reason is the text given by the server to explain why this player has been kicked from the game. </li>
</ul>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="network_8h_source.html">network.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
